stages:
  - test
  - build
  - release

variables:
  TERRAFORM_REGISTRY_MODULE_NAME: tools-k8s
  TERRAFORM_REGISTRY_SYSTEM_NAME: listmonk
  TERRAFORM_MODULE_PATH: ./terraform_module
  TERRAFORM_OUT_DIRECTORY: ./out/terraform
  HELM_CHART_NAME: listmonk

include:
  - project: vigigloo/gitlab-pipeline-fragments
    ref: v1
    file:
      - registry/terraform.yml
      - registry/helm.auto.yml

vigigloo:
  stage: .pre
  image:
    name: registry.gitlab.com/vigigloo/cli:dslim-v1.1.0
    entrypoint: [""]
  script:
    - vigigloo assist
  artifacts:
    paths:
      - terraform_module


registry:terraform:init:
  extends: .vigigloo:registry:terraform:init
  interruptible: true
  stage: .pre
  needs:
    - job: vigigloo
      artifacts: true

registry:terraform:validate:
  extends: .vigigloo:registry:terraform:validate
  interruptible: true
  stage: test

registry:terraform:build:
  extends: .vigigloo:registry:terraform:build
  stage: build
  artifacts:
    paths:
      - out

registry:terraform:upload:
  extends: .vigigloo:registry:terraform:upload
  stage: release
  needs:
    - job: registry:terraform:build
      artifacts: true
    - job: vigigloo
      artifacts: true
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH

".vigigloo:terraform":
  image:
    name: hashicorp/terraform:1.5

